#include "package.h"

Package::Package()
{
    reposList << "Rosa" << "Cooker" << "Mageia" << "PCLinuxOS" << "Sisyphus" << "OpenSUSE" << "Fedora" << "Gentoo" << "Debian" << "Ubuntu";
}

bool Package::operator<(const Package &other) const
{
    if (this->name < other.name)
        return true;
    if (this->name == other.name)
    {
        if (checker.firstVersionLess(this->version, other.version))
            return true;
        if (this->version == other.version)
        {
            int thisRepo = getRepoPriority(this->source);
            int otherRepo = getRepoPriority(other.source);
            if (thisRepo > otherRepo)
                return true;
            if ((thisRepo == otherRepo) && (this->release < other.release))
                return true;
        }
    }
    return false;
}

int Package::getRepoPriority(const QString repo) const
{
    int j = 0;
    while (j < reposList.count())
    {
        if (repo != reposList.at(j))
            j++;
        else
            break;
    }
    return j;
}
