#include "packagedb.h"

PackageDB::PackageDB()
{
    configPath = QDir::homePath() + "/.config/mib-report/";
    if (!configPath.exists())
    {
        QDir().mkpath(configPath.path());
    }

    statusOK = false;
    statusString = "DB not initialized";
}

/* ============== public functions ============== */

int PackageDB::updateLists()
{
    QTextStream out(stderr);
    int errorCode;

    out << "Downloading Rosa 2012.1 Main lists" << endl;
    out.flush();
    system("lynx --dump http://abf.rosalinux.ru/downloads/rosa2012.1/repository/SRPMS/main/release/ | egrep -o \"http:.*\" | grep src > $HOME/.config/mib-report/rosa.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Rosa 2012.1 Contrib lists" << endl;
    out.flush();
    system("lynx --dump http://abf.rosalinux.ru/downloads/rosa2012.1/repository/SRPMS/contrib/release/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/rosa.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Rosa 2012.1 Non-Free lists" << endl;
    out.flush();
    system("lynx --dump http://abf.rosalinux.ru/downloads/rosa2012.1/repository/SRPMS/non-free/release/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/rosa.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Rosa 2012.1 Restricted lists" << endl;
    out.flush();
    system("lynx --dump http://abf.rosalinux.ru/downloads/rosa2012.1/repository/SRPMS/restricted/release/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/rosa.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Mandriva Cooker Main lists" << endl;
    out.flush();
    system("lynx --dump http://distrib-coffee.ipsl.jussieu.fr/pub/linux/MandrivaLinux/devel/cooker/SRPMS/main/release/ | egrep -o \"http:.*\" | grep src > $HOME/.config/mib-report/cooker.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Mandriva Cooker Contrib lists" << endl;
    out.flush();
    system("lynx --dump http://distrib-coffee.ipsl.jussieu.fr/pub/linux/MandrivaLinux/devel/cooker/SRPMS/contrib/release/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/cooker.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Mandriva Cooker Non-Free lists" << endl;
    out.flush();
    system("lynx --dump http://distrib-coffee.ipsl.jussieu.fr/pub/linux/MandrivaLinux/devel/cooker/SRPMS/non-free/release/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/cooker.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Mageia Cauldron Core lists" << endl;
    out.flush();
    system("lynx --dump http://distrib-coffee.ipsl.jussieu.fr/pub/linux/Mageia/distrib/cauldron/SRPMS/core/release/ | egrep -o \"http:.*\" | grep src > $HOME/.config/mib-report/cauldron.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Mageia Cauldron Tainted lists" << endl;
    out.flush();
    system("lynx --dump http://distrib-coffee.ipsl.jussieu.fr/pub/linux/Mageia/distrib/cauldron/SRPMS/tainted/release/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/cauldron.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Mageia Cauldron Non-Free lists" << endl;
    out.flush();
    system("lynx --dump http://distrib-coffee.ipsl.jussieu.fr/pub/linux/Mageia/distrib/cauldron/SRPMS/nonfree/release/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/cauldron.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading PCLinuxOS Main lists" << endl;
    out.flush();
    system("lynx --dump http://distrib-coffee.ipsl.jussieu.fr/pub/linux/pclinuxos/apt/pclinuxos/2010/SRPMS.main/ | egrep -o \"http:.*\" | grep src > $HOME/.config/mib-report/pclinuxos.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading PCLinuxOS Updates lists" << endl;
    out.flush();
    system("lynx --dump http://distrib-coffee.ipsl.jussieu.fr/pub/linux/pclinuxos/apt/pclinuxos/2010/SRPMS.updates/ | egrep -o \"http:.*\" | grep src > $HOME/.config/mib-report/pclinuxos.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading PCLinuxOS Games lists" << endl;
    out.flush();
    system("lynx --dump http://distrib-coffee.ipsl.jussieu.fr/pub/linux/pclinuxos/apt/pclinuxos/2010/SRPMS.games/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/pclinuxos.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Fedora Rawhide lists" << endl;
    out.flush();
    errorCode = system("curl -o $HOME/.config/mib-report/fedora.gz -# `lynx --dump http://mirror.yandex.ru/fedora/linux/development/rawhide/source/SRPMS/repodata/ | egrep -o \"http:.*\" | grep primary.xml.gz`");
    if (errorCode)
        return errorCode;
    errorCode = system("zcat $HOME/.config/mib-report/fedora.gz | grep src.rpm | sed s,\\\"/\\>,,g | sed s,\\<location\\ href=\\\",http://mirror.yandex.ru/fedora/linux/development/rawhide/source/SRPMS/,g > $HOME/.config/mib-report/fedora.txt");
    if (errorCode)
        return errorCode;
    system("rm -f $HOME/.config/mib-report/fedora.gz");
    out.flush();

    out << "Downloading Fedora Rawhide RPM Fusion Free lists" << endl;
    out.flush();
    system("lynx --dump http://download1.rpmfusion.org/free/fedora/development/source/SRPMS/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/fedora.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Fedora Rawhide RPM Fusion Non-Free lists" << endl;
    out.flush();
    system("lynx --dump http://download1.rpmfusion.org/nonfree/fedora/development/source/SRPMS/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/fedora.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Alt Linux Sisyphus lists" << endl;
    out.flush();
    system("lynx --dump http://mirror.yandex.ru/altlinux/Sisyphus/files/SRPMS/ | egrep -o \"http:.*\" | grep src > $HOME/.config/mib-report/sisyphus.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading OpenSUSE OSS lists" << endl;
    out.flush();
    system("lynx --dump http://download.opensuse.org/source/factory/repo/oss/suse/src/ | egrep -o \"http:.*\" | grep src > $HOME/.config/mib-report/opensuse.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading OpenSUSE Non-OSS lists" << endl;
    out.flush();
    system("lynx --dump http://download.opensuse.org/source/factory/repo/non-oss/suse/src/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/opensuse.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading OpenSUSE Emulators lists" << endl;
    out.flush();
    system("lynx --dump http://ftp5.gwdg.de/pub/opensuse/repositories/Emulators/openSUSE_Factory/src/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/opensuse.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Gentoo lists" << endl;
    out.flush();
    errorCode = system("curl -# -o $HOME/.config/mib-report/portage-latest.tar.bz2 http://mirror.yandex.ru/gentoo-distfiles/snapshots/portage-latest.tar.bz2");
    if (errorCode)
        return errorCode;
    out << "Preparing downloaded Gentoo lists" << endl;
    out.flush();
    errorCode = system("tar -tjf $HOME/.config/mib-report/portage-latest.tar.bz2 | grep ebuild | grep -v \"9999\" | sed s/-r.*ebuild/.ebuild/g | sed s/.ebuild/-1.ebuild/g > $HOME/.config/mib-report/gentoo.txt");
    if (errorCode)
        return errorCode;
    system("rm -f $HOME/.config/mib-report/portage-latest.tar.bz2");

    out << "Downloading Debian lists" << endl;
    out.flush();
    errorCode = system("curl -# -o $HOME/.config/mib-report/ls-lR.gz http://mirror.yandex.ru/debian/ls-lR.gz");
    if (errorCode)
        return errorCode;
    out << "Preparing downloaded Debian lists" << endl;
    out.flush();
    errorCode = system("zcat $HOME/.config/mib-report/ls-lR.gz | grep \"dsc\" | sed s/_/-/g | awk '{print $9;}' | sed s/+.*dsc/-1.dsc/g > $HOME/.config/mib-report/debian.txt");
    if (errorCode)
        return errorCode;
    system("rm -f $HOME/.config/mib-report/ls-lR.gz");

    out << "Downloading Ubuntu lists" << endl;
    out.flush();
    errorCode = system("curl -# -o $HOME/.config/mib-report/ls-lR.gz http://mirror.yandex.ru/ubuntu/ls-lR.gz");
    if (errorCode)
        return errorCode;
    out << "Preparing downloaded Ubuntu lists" << endl;
    out.flush();
    errorCode = system("zcat $HOME/.config/mib-report/ls-lR.gz | grep \"dsc\" | sed s/_/-/g | awk '{print $9;}' | sed s/+.*dsc/-1.dsc/g > $HOME/.config/mib-report/ubuntu.txt");
    if (errorCode)
        return errorCode;
    system("rm -f $HOME/.config/mib-report/ls-lR.gz");

    out << "Done" << endl;
    return 0;
}

void PackageDB::initDB()
{  
    newPackagesList.clear();
    fullPackagesList.clear();

    rosaRepo.name = "Rosa";
    cookerRepo.name = "Cooker";
    mageiaRepo.name = "Mageia";
    fedoraRepo.name = "Fedora";
    pclinuxosRepo.name = "PCLinuxOS";
    sisyphusRepo.name = "Sisyphus";
    opensuseRepo.name = "OpenSUSE";
    gentooRepo.name = "Gentoo";
    debianRepo.name = "Debian";
    ubuntuRepo.name = "Ubuntu";

    statusOK = true;
    statusString = "OK";

    readBlacklist();
    readUrls();
    readPackages("rosa.txt", rosaRepo.list, rosaRepo.name);
    readPackages("cooker.txt", cookerRepo.list, cookerRepo.name);
    readPackages("cauldron.txt", mageiaRepo.list, mageiaRepo.name);
    readPackages("fedora.txt", fedoraRepo.list, fedoraRepo.name);
    readPackages("pclinuxos.txt", pclinuxosRepo.list, pclinuxosRepo.name);
    readPackages("sisyphus.txt", sisyphusRepo.list, sisyphusRepo.name);
    readPackages("opensuse.txt", opensuseRepo.list, opensuseRepo.name);
    readPackages("gentoo.txt", gentooRepo.list, gentooRepo.name);
    readPackages("debian.txt", debianRepo.list, debianRepo.name);
    readPackages("ubuntu.txt", ubuntuRepo.list, ubuntuRepo.name);

    fullPackagesList << rosaRepo.list << cookerRepo.list << mageiaRepo.list << fedoraRepo.list << pclinuxosRepo.list << sisyphusRepo.list << opensuseRepo.list << gentooRepo.list << debianRepo.list << ubuntuRepo.list;

    newPackagesList << fullPackagesList;
    removeOlds(newPackagesList);
}

void PackageDB::generateHTMLTable(Repo refRepo, Repo compRepo, int mode)
{
    QTextStream out(stdout);
    QTextStream outerr(stderr);
    outerr << "Table generation started" << endl;
    out << "<html><head>" << endl;
    out << "<title>" + refRepo.name + " vs " + compRepo.name + " Packages Table</title>" << endl;
    out << "<style type=\"text/css\">" << endl;
    out << "th {background-color:#CCCCCC; border: 1px solid black; padding-right: 10px; padding-left: 10px; font-weight:bold;}" << endl;
    out << "th.bottom {border-top: 2px solid black; text-align:center; padding-right: 2px; padding-left: 2px;}" << endl;
    out << "td {border: 1px solid black; padding-right: 2px; padding-left: 2px;}" << endl;
    out << "table {border: 1px solid black; border-collapse:collapse;}" << endl;
    out << "td.old {background-color:#FFFFCC;}" << endl;
    out << "td.new {background-color:#CCFFCC;}" << endl;
    out << "td.none {background-color:#FFCCCC;}" << endl;
    out << "a {color:#000000; text-decoration:none;}" << endl;
    out << "a:hover {text-decoration:underline;}" << endl;
    out << "</style>" << endl;
    out << "</head><body><p><table>" << endl;
    out << "<tr><th colspan=5>" + refRepo.name + " vs " + compRepo.name + " packages report (generated at " << QDate::currentDate().toString(Qt::ISODate) << ")</th></tr>" << endl;
    out << "<tr><th>Name</th><th>" + refRepo.name + " exclusive</th><th>" + refRepo.name + "</th><th>" + compRepo.name + "</th><th>Latest version (where)</th></tr>";

    int refExclusiveCount = 0;
    int newAvailableCount = 0;
    int refOutdated = 0;
    int compLess = 0;
    int inRef = 0;
    int inComp = 0;
    for (int j = 0; j < refRepo.list.count(); j++)
    {
        QString latestVersion = getPackageVersion(refRepo.list.at(j).name, newPackagesList);
        QString refVersion = getPackageVersion(refRepo.list.at(j).name, refRepo.list);
        if (refVersion != latestVersion)
            refOutdated++;
        QString compVersion = getPackageVersion(refRepo.list.at(j).name, compRepo.list);
        bool refExclusive = false;
        bool show = false;
        QString source;
        QString sourceUrl;
        QString homepage;
        if (getPackageVersion(refRepo.list.at(j).name, compRepo.list) == "none")
        {
            refExclusive = true;
            refExclusiveCount++;
        }

        bool versionLess = checker.firstVersionLess(compVersion, refVersion);
        if (!refExclusive && versionLess)
            compLess++;

        if ((mode == REPORT_ALL) && (compVersion != latestVersion) && versionLess)
        {
            show = true;
        }
        else if ((mode == REPORT_EXCLUSIVES) && refExclusive)
        {
            show = true;
        }
        else if ((mode == REPORT_UPDATES) && !refExclusive && (compVersion != latestVersion) && versionLess)
        {
            show = true;
        }

        if (show)
        {
            if (compVersion != "none")
                inComp++;
            if (refVersion != "none")
                inRef++;

            out << "<tr>" << endl;;
            out << "<td>";
            homepage = getPackageHomepage(refRepo.list.at(j).name);
            if (!homepage.isEmpty())
                out << "<a href=\"" << homepage << "\">";
            out << refRepo.list.at(j).name;
            if (!homepage.isEmpty())
                out << "</a>";
            out << "</td>" << endl;

            out << "<td>";
            if (refExclusive)
                out << "Yes";
            else
                out << "No";
            out << "</td>" << endl;

            if (refVersion == latestVersion)
                out << "<td class=\"new\">";
            else
                out << "<td class=\"old\">";
            sourceUrl = getPackageSourceUrl(refRepo.list.at(j).name, refRepo.list);
            if (!sourceUrl.isEmpty())
                out << "<a href=\"" << sourceUrl << "\">";
            out << refVersion;
            if (!sourceUrl.isEmpty())
                out << "</a>";
            out << "</td>" << endl;

            if ((compVersion == "none") && refExclusive)
                out << "<td class=\"none\">";
            else if (compVersion == latestVersion)
                out << "<td class=\"new\">";
            else
                out << "<td class=\"old\">";
            sourceUrl = getPackageSourceUrl(refRepo.list.at(j).name, compRepo.list);
            if (!sourceUrl.isEmpty())
                out << "<a href=\"" << sourceUrl << "\">";
            out << compVersion;
            if (!sourceUrl.isEmpty())
                out << "</a>";
            out << "</td>" << endl;

            out << "<td>";
            sourceUrl = getPackageSourceUrl(refRepo.list.at(j).name, newPackagesList);
            if (!sourceUrl.isEmpty())
                out << "<a href=\"" << sourceUrl << "\">";
            out << latestVersion;

            source = getPackageSource(refRepo.list.at(j).name, newPackagesList);
            if (!source.contains(compRepo.name))
                newAvailableCount++;
            out << " (" << source << ")";
            if (!sourceUrl.isEmpty())
                out << "</a>";
            out << "</td>" << endl;

            out << "</tr>" << endl;
        }
    }

//  now statistics for compared repo
    int compExclusiveCount = 0;
    int compOutdated = 0;
    int refLess = 0;
    for (int j = 0; j <  compRepo.list.count(); j++)
    {
        bool compExclusive = false;
        if (getPackageVersion(compRepo.list.at(j).name, refRepo.list) == "none")
        {
            compExclusive = true;
            compExclusiveCount++;
        }
        QString latestVersion = getPackageVersion(compRepo.list.at(j).name, newPackagesList);
        QString compVersion = getPackageVersion(compRepo.list.at(j).name, compRepo.list);
        QString refVersion = getPackageVersion(compRepo.list.at(j).name, refRepo.list);
        if (compVersion != latestVersion)
            compOutdated++;

        bool versionLess = checker.firstVersionLess(refVersion, compVersion);
        if (!compExclusive && versionLess)
            refLess++;
    }

    out << "<tr><th colspan=5 class=\"Bottom\">Statistics</th></tr>" << endl;
    out << "<tr><th>Distrib</th><th>Total packages</th><th>Exclusives</th><th>Outdated VS</th><th>Outdated total</th></tr>";

    out << "<tr><td>" << refRepo.name << "</td>";
    out << "<td>" << refRepo.list.count() << "</td>";
    out << "<td>" << refExclusiveCount << "</td>";
    out << "<td>" << refLess << "</td>";
    out << "<td>" << refOutdated << "</td></tr>";

    out << "<tr><td>" << compRepo.name << "</td>";
    out << "<td>" << compRepo.list.count() << "</td>";
    out << "<td>" << compExclusiveCount << "</td>";
    out << "<td>" << compLess << "</td>";
    out << "<td>" << compOutdated << "</td></tr>";
    out << "</table></p></body></html>" << endl;
    outerr << "Table generation complete" << endl;
}


void PackageDB::search(QString packageName)
{
    QTextStream out(stderr);
    bool found = false;
    for (int j = 0; j < fullPackagesList.count(); j++)
    {
        if (packageName == fullPackagesList.at(j).name)
        {
            found = true;
            out << fullPackagesList.at(j).source << ": ";
            out << fullPackagesList.at(j).version << endl;          
            QString sourceUrl;
            if (fullPackagesList.at(j).sourceUrl.contains("http://"))
                sourceUrl = fullPackagesList.at(j).sourceUrl;
            else if (fullPackagesList.at(j).source == "Gentoo")
                sourceUrl = "http://packages.gentoo.org/package/" + packageName;
            else if (fullPackagesList.at(j).source == "Debian")
                sourceUrl = "http://packages.debian.org/" + packageName;
            else if (fullPackagesList.at(j).source == "Ubuntu")
                sourceUrl = "http://packages.ubuntu.com/" + packageName;
            out << sourceUrl << endl;
        }
    }
    if (!found)
        out << "Package " << packageName << " not found" << endl;
    else
        out << "Homepage URL: " << endl << getPackageHomepage(packageName) << endl;
}

void PackageDB::displayList(QList<Package> &packageList)
{
    QTextStream out(stderr);
    for (int j = 0; j < packageList.count(); j++)
    {
        out << packageList.at(j).name << " " << packageList.at(j).version << " " << packageList.at(j).source << endl;
    }
}

/* ============== private functions ============== */

QString PackageDB::getPackageVersion(QString packageName, QList<Package> &packageList)
{
    QString version = "none";
    for (int j = 0; j < packageList.count(); j++)
    {
        if (packageName == packageList.at(j).name)
        {
            version = packageList.at(j).version;
            break;
        }
    }
    return version;
}

QString PackageDB::getPackageSource(QString packageName, QList<Package> &packageList)
{
    QString source = "";
    for (int j = 0; j < packageList.count(); j++)
    {
        if (packageName == packageList.at(j).name)
        {
            source = packageList.at(j).source;
            break;
        }
    }
    return source;
}

QString PackageDB::getPackageSourceUrl(QString packageName, QList<Package> &packageList)
{
    QString sourceUrl = "";
    for (int j = 0; j < packageList.count(); j++)
    {
        if (packageName == packageList.at(j).name)
        {
            if (packageList.at(j).sourceUrl.contains("http://"))
                sourceUrl = packageList.at(j).sourceUrl;
            else if (packageList.at(j).source == "Gentoo")
                sourceUrl = "http://packages.gentoo.org/package/" + packageName;
            else if (packageList.at(j).source == "Debian")
                sourceUrl = "http://packages.debian.org/" + packageName;
            else if (packageList.at(j).source == "Ubuntu")
                sourceUrl = "http://packages.ubuntu.com/" + packageName;
            break;
        }
    }
    return sourceUrl;
}

QString PackageDB::getUpdatedSourceUrl(QString inFileName, Package inPackage)
{
    QString updatedSourceUrl = "";
    QTextStream out(stderr);
    QFile inFile;
    inFile.setFileName(configPath.absolutePath() + "/" + inFileName);
    if (!inFile.open(QIODevice::ReadOnly | QIODevice::Text))
    {
        out << "Error opening file " << configPath.absolutePath() << "/" << inFileName << "!\n";
        statusOK = false;
        statusString = "Error opening file " + configPath.absolutePath() + "/" + inFileName;
    }
    else
    {
        QTextStream fileIn(&inFile);

        // hack for rebuilt packages
        inPackage.sourceUrl.remove("mib2010.2.src.rpm");
        inPackage.sourceUrl.remove("mib2010.1.src.rpm");
        inPackage.sourceUrl.remove("mib2009.1.src.rpm");
        inPackage.sourceUrl.remove(".src.rpm");

        while (!fileIn.atEnd())
        {
            QString line = fileIn.readLine();
            if (line.contains(inPackage.sourceUrl))
            {
                updatedSourceUrl = line;
                break;
            }
        }
        inFile.close();
    }
    return updatedSourceUrl;
}

void PackageDB::updateListSourceUrls(QString inFileName, QList<Package> &packageList)
{
    for (int j = 0; j < packageList.count(); j++)
    {
        packageList[j].sourceUrl = getUpdatedSourceUrl(inFileName, packageList.at(j));
    }
}

void PackageDB::removeOlds(QList<Package> &packageList)
{
    qSort(packageList);
    int j = 0;
    while (j < packageList.count() - 1)
    {
        if ((packageList.at(j).name == packageList.at(j+1).name) && ((packageList.at(j).version == packageList.at(j+1).version) || checker.firstVersionLess(packageList.at(j).version, packageList.at(j+1).version)))
            packageList.removeAt(j);
        else
            j++;
    }
}

bool PackageDB::readPackages(QString inFileName, QList<Package> &packageList, QString packageSource)
{
    QTextStream out(stderr);
    QFile inFile;
    inFile.setFileName(configPath.absolutePath() + "/" + inFileName);
    if (!inFile.open(QIODevice::ReadOnly | QIODevice::Text))
    {
        out << "Error opening file " << configPath.absolutePath() << "/" << inFileName << "!\n";
        statusOK = false;
        statusString = "Error opening file " + configPath.absolutePath() + "/" + inFileName;
        return false;
    }
    else
    {
        QTextStream fileIn(&inFile);
        while (!fileIn.atEnd())
        {
            Package tempPackage;
            QString line = fileIn.readLine();
            tempPackage.sourceUrl = line;
            line = line.right(line.length() - line.lastIndexOf("/") - 1);
            tempPackage.release = line.right(line.length() - line.lastIndexOf("-") - 1);
            line = line.left(line.lastIndexOf("-"));
            tempPackage.name = line.left(line.lastIndexOf("-")).toLower();
            tempPackage.version = line.right(line.length() - line.lastIndexOf("-") - 1);
            tempPackage.source = packageSource;
            if (!tempPackage.name.isEmpty() && !tempPackage.version.isEmpty() && !checker.isVersionBad(tempPackage.version) && !isBlacklisted(tempPackage))
                packageList.append(tempPackage);
        }
        inFile.close();
        removeOlds(packageList);
        return true;
    }
}

bool PackageDB::readBlacklist()
{
    blackList.clear();
    QFile inFile;

    inFile.setFileName(QDir::rootPath() + "/usr/share/mib-report/blacklist.txt");
    if (!inFile.open(QIODevice::ReadOnly | QIODevice::Text))
    {
        statusOK = false;
        statusString = "Error opening blacklist file " + QDir::rootPath() + "usr/share/mib-report/blacklist.txt";
        return false;
    }
    else
    {
        QTextStream fileIn(&inFile);
        while (!fileIn.atEnd())
        {
            Package tempPackage;
            QString line = fileIn.readLine();
            tempPackage.source = line.left(line.lastIndexOf(":")).simplified();
            tempPackage.name = line.right(line.length() - line.lastIndexOf(":") - 2).toLower().simplified();
            if (!tempPackage.name.isEmpty() && !tempPackage.source.isEmpty())
                blackList.append(tempPackage);
        }
        inFile.close();
        return true;
    }
}

bool PackageDB::isBlacklisted(Package inPackage)
{
    bool blacklisted = false;
    for (int j = 0; j < blackList.count(); j++)
    {
        if ((inPackage.name == blackList.at(j).name) && (inPackage.source == blackList.at(j).source))
        {
            blacklisted = true;
            break;
        }
    }
    return blacklisted;
}

bool PackageDB::readUrls()
{
    urlsList.clear();
    QFile inFile;

    inFile.setFileName(QDir::rootPath() + "/usr/share/mib-report/urls.txt");
    if (!inFile.open(QIODevice::ReadOnly | QIODevice::Text))
    {
        statusOK = false;
        statusString = "Error opening urls file " + QDir::rootPath() + "usr/share/mib-report/urls.txt";
        return false;
    }
    else
    {
        QTextStream fileIn(&inFile);
        while (!fileIn.atEnd())
        {
            Package tempPackage;
            QString line = fileIn.readLine();
            tempPackage.name = line.left(line.indexOf(":")).toLower().simplified();
            tempPackage.homepage = line.right(line.length() - line.indexOf(":") - 2).toLower().simplified();
            if (!tempPackage.name.isEmpty() && !tempPackage.homepage.isEmpty())
                urlsList.append(tempPackage);
        }
        inFile.close();
        return true;
    }
}

QString PackageDB::getPackageHomepage(QString packageName)
{
    QString homepage = "";
    for (int j = 0; j < urlsList.count(); j++)
    {
        if (packageName == urlsList.at(j).name)
        {
            homepage = urlsList.at(j).homepage;
            break;
        }
    }
    return homepage;
}


